// JavaScript Document


// create an array for the 10 selected countries to convert currency to
var countryList = new Array('Euro - EUR', 'Hong Kong Dollar - HKD', 'United Kingdom Pounds - GBP',
							'Canadian Dollars - CAD', 'Australian Dollars - AUD', 'Japan Yen - JPY',
							'Indian Rupee - INR', 'New Zealand Dollars - NZD', 'Switzerland Francs - CHF',
							'South Africa Rand - ZAR');

// carefully create a corresponding array of the currency conversion factors
var currencyList = new Array(0.736142, 7.81415, 0.499689, 
							 1.12225, 1.19825, 118.370,
							 41.7003, 1.34250, 1.20729,
							 7.04369);

// this function initializes the whole Web page
function initializePage()
{
	createCountryOpts();   // put all the countries into the <select> element
	resetAmountInput();    // clear the amount field
	resetAnswerOutput();   // clear the output field
}

// this function populates the <select> element
function createCountryOpts()
{
	// get the <select> element to work with
	var currencySelect = document.getElementById('convert2');
	
	// variable to hold the new <option> element
	var newOpt;
	
	// a simple counter for the for loop
	var i;
	
	// for loop creates a new <option> element, assigns the text and value attributes, and 
	// adds the attribute to the <select> element
	for(i = 0; i < currencyList.length; i++)
	{
		newOpt = document.createElement('option');
		newOpt.text = countryList[i];      // adds the value for text attribute for the <select> element
		newOpt.value = currencyList[i];    // adds the conversion factor corresponding to the country
		
		// try catch block that handles the different requirements for IE vs. other browsers
		try
		{
			currencySelect.add(newOpt, null);	
		}
		catch(ex)
		{
			currencySelect.add(newOpt);	
		}
	}
}

// this function initializes/resets the text input and value for the <input> element for the currency to convert from
function resetAmountInput()
{
	var amount = document.getElementById('currAmount');
	amount.text = 1.00;
	amount.value = 1.00;
}

// this function initializes/resets the text output and value for the answer <input> element
function resetAnswerOutput()
{
	var answer = document.getElementById('answer');
	answer.text = '';
	answer.value = '';
}

// this function converts the currency from the students chosen 'from' currency to the selected 'to' currency
function convertCurrency()
{
	var currSelect = document.getElementById('convert2');
	var selIndex = 	currSelect.selectedIndex; // get the selected index of from the <select> element
	var convFact = currSelect.options[selIndex].value; // get the conversion factor 
	var convText = currSelect.options[selIndex].text;  // get the conversion country
	
	var currAmountElt = document.getElementById('currAmount');
	var currAmountVal = currAmountElt.value;
	
	// use RegEx validation to ensure that the input is in correct format for the 'from' conversion rate
	if(usdValidation(currAmountVal) == false)
	{
		convOutput.value = 'INPUT ERROR: Input must be in the form of DDDD.CC';
		return;	
	}
	
	// get the output <input> element
	var convOutput = document.getElementById('answer');
	
	// parse the digits before the decimal
	var usdDollar = Math.floor(eval(currAmountVal));
	
	// parse the digits after the decimal
	var usdCents = eval(currAmountVal) - Math.floor(usdDollar);
	usdCents = Math.round(100 * eval(usdCents)) * 0.01;
	
	// simple counter variable for for loop
	var i;
	
	// variable to hold the converted currency
	// important to initialize to some numerical form
	var convertedCurrency = eval(0);
	
	// loop that converts usd to specified dollar amount
	for(i = 0; i < eval(usdDollar); i++)
	{
		convertedCurrency = eval(convertedCurrency) + eval(convFact);
	}
	
	// loop that adds the converted amount of the value that comes after the decimal
	convertedCurrency = eval(convertedCurrency) + (eval(convFact) * eval(usdCents));
	
	// method that performs output to the <input> element
	writeAnswer(convertedCurrency, usdDollar, usdCents);
}

// this function writes output to the <input> that holds the answer
function writeAnswer(convCurr, usdD, usdC)
{
	// reset the output before writing the new answer
	resetAnswerOutput();
	
	// get a numerical version of the converted currency
	var usdVal = eval(usdD) + eval(usdC);
	
	// get the answer <select> element
	var answerInput = document.getElementById('answer');
	
	// (1) parse out the amount before the decimal
	var convDollar = Math.floor(eval(convCurr));
	
	// (2) parse out the amount after the decimal
	var convCents = eval(convCurr) - eval(convDollar);
	
	convCents = Math.floor(eval(convCents) * 10000000) * 0.0000001;
	
	// combine (1) and (2)
	convCurr = eval(convDollar) + eval(convCents);

	// get the 'from' currency
	var curInput = document.getElementById('currAmount');
	
	// get the 'to' currency
	var currSelect = document.getElementById('convert2');
	
	// get the selected country and for output
	var selText = currSelect.options[currSelect.selectedIndex].text;
	var selVal = currSelect.options[currSelect.selectedIndex].value;
	
	var answerText; // holds the text for the answer
	
	// if statement controls which output should occur given the format of the input
	if(eval(usdC) == 0) // if there is not value after the decimal
	{
		answerText = 'Converted $' + usdVal + '.00USD to ' + convCurr + ' in ' + selText;
	}
	else if(((eval(usdC) * 100) % 10) == 0 && eval(usdC) >= 0.1) 
	{
		// if the value after the decimal is a multiple of 10
		answerText = 'Converted $' + usdVal + '0USD to ' + convCurr + ' in ' + selText;
	}
	else // if there is a value after the decimal
	{
		answerText = 'Converted $' + usdVal + 'USD to ' + convCurr + ' in ' + selText;
	}
	
	// set the value of the answer <input>
	answerInput.value = answerText;
	
}

// this function validates the input for the 'from' currency
function usdValidation(amount)
{
	var re = /^\d+([.]\d\d)?$/;

	if(re.test(amount) == true)
		return true;
	else
		return false;
}